diff --git a/hmp.c b/hmp.c
index ccc95d3feb..89cdaebfde 100644
--- a/hmp.c
+++ b/hmp.c
@@ -54,6 +54,7 @@
 #include "hw/rdma/rdma.h"
 #include "migration/snapshot.h"
 #include "migration/misc.h"
+#include "hw/boards.h"
 
 #ifdef CONFIG_SPICE
 #include <spice/enums.h>
@@ -2178,9 +2179,17 @@ void hmp_device_add(Monitor *mon, const QDict *qdict)
 
 void hmp_device_del(Monitor *mon, const QDict *qdict)
 {
+    MachineState *ms = MACHINE(current_machine);
     const char *id = qdict_get_str(qdict, "id");
     Error *err = NULL;
 
+#ifdef CONFIG_MPQEMU
+    if (g_hash_table_lookup(ms->remote_devs, id)) {
+        qmp_rdevice_del(id, &err);
+        return;
+    }
+#endif
+
     qmp_device_del(id, &err);
     hmp_handle_error(mon, &err);
 }
diff --git a/hw/proxy/monitor.c b/hw/proxy/monitor.c
index 400c83c0d5..c4d0ff1213 100644
--- a/hw/proxy/monitor.c
+++ b/hw/proxy/monitor.c
@@ -172,6 +172,8 @@ static void rdevice_add_del(QDict *qdict, proc_cmd_t cmd, Error **errp)
     if (cmd == DEVICE_ADD) {
         (void)g_hash_table_insert(ms->remote_devs, (gpointer)g_strdup(id),
                                   (gpointer)pdev);
+    } else {
+        (void)g_hash_table_remove(ms->remote_devs, (gpointer)id);
     }
 }
 
@@ -179,3 +181,16 @@ void qmp_rdevice_add(QDict *qdict, QObject **ret_data, Error **errp)
 {
     rdevice_add_del(qdict, DEVICE_ADD, errp);
 }
+
+void qmp_rdevice_del(const char *id, Error **errp)
+{
+    QDict *qdict = qdict_new();
+
+    qdict_put_str(qdict, "id", id);
+
+    qdict_put_str(qdict, "rid", id);
+
+    rdevice_add_del(qdict, DEVICE_DEL, errp);
+
+    qobject_unref(qdict);
+}
diff --git a/include/hw/qdev-core.h b/include/hw/qdev-core.h
index 33ed3b8dde..cea42a92ab 100644
--- a/include/hw/qdev-core.h
+++ b/include/hw/qdev-core.h
@@ -358,6 +358,7 @@ BusState *qdev_get_parent_bus(DeviceState *dev);
 /*** BUS API. ***/
 
 DeviceState *qdev_find_recursive(BusState *bus, const char *id);
+DeviceState *find_device_state(const char *id, Error **errp);
 
 /* Returns 0 to walk children, > 0 to skip walk, < 0 to terminate walk. */
 typedef int (qbus_walkerfn)(BusState *bus, void *opaque);
diff --git a/include/io/proxy-link.h b/include/io/proxy-link.h
index 07a08a9175..bf2555c97e 100644
--- a/include/io/proxy-link.h
+++ b/include/io/proxy-link.h
@@ -61,6 +61,7 @@ typedef struct ProxyLinkState ProxyLinkState;
  * SET_IRQFD        Sets the IRQFD to be used to raise interrupts directly
  *                  from remote device
  * DEVICE_ADD       QMP/HMP command to hotplug device
+ * DEVICE_DEL       QMP/HMP command to hot-unplug device
  *
  */
 typedef enum {
@@ -72,6 +73,7 @@ typedef enum {
     BAR_READ,
     SET_IRQFD,
     DEVICE_ADD,
+    DEVICE_DEL,
     MAX,
 } proc_cmd_t;
 
diff --git a/include/monitor/qdev.h b/include/monitor/qdev.h
index e21692677e..c7642f7c2d 100644
--- a/include/monitor/qdev.h
+++ b/include/monitor/qdev.h
@@ -11,6 +11,7 @@ void hmp_info_qom_tree(Monitor *mon, const QDict *dict);
 void qmp_device_add(QDict *qdict, QObject **ret_data, Error **errp);
 
 void qmp_rdevice_add(QDict *qdict, QObject **ret_data, Error **errp);
+void qmp_rdevice_del(const char *id, Error **errp);
 
 int qdev_device_help(QemuOpts *opts);
 DeviceState *qdev_device_add(QemuOpts *opts, Error **errp);
diff --git a/qdev-monitor.c b/qdev-monitor.c
index 80d570263f..744c807b0f 100644
--- a/qdev-monitor.c
+++ b/qdev-monitor.c
@@ -34,6 +34,7 @@
 #include "qemu/qemu-print.h"
 #include "sysemu/block-backend.h"
 #include "migration/misc.h"
+#include "hw/boards.h"
 
 /*
  * Aliases were a bad idea from the start.  Let's keep them
@@ -827,7 +828,7 @@ void qmp_device_add(QDict *qdict, QObject **ret_data, Error **errp)
     object_unref(OBJECT(dev));
 }
 
-static DeviceState *find_device_state(const char *id, Error **errp)
+DeviceState *find_device_state(const char *id, Error **errp)
 {
     Object *obj;
 
@@ -902,7 +903,17 @@ void qdev_unplug(DeviceState *dev, Error **errp)
 
 void qmp_device_del(const char *id, Error **errp)
 {
-    DeviceState *dev = find_device_state(id, errp);
+    MachineState *ms = MACHINE(current_machine);
+    DeviceState *dev;
+
+#ifdef CONFIG_MPQEMU
+    if (g_hash_table_lookup(ms->remote_devs, id)) {
+        qmp_rdevice_del(id, errp);
+        return;
+    }
+#endif
+
+    dev = find_device_state(id, errp);
     if (dev != NULL) {
         qdev_unplug(dev, errp);
     }
diff --git a/remote/remote-main.c b/remote/remote-main.c
index ba39ab6a46..c5dc7c0009 100644
--- a/remote/remote-main.c
+++ b/remote/remote-main.c
@@ -53,6 +53,7 @@
 #include "qemu/option.h"
 #include "qemu/config-file.h"
 #include "monitor/qdev.h"
+#include "qapi/qmp/qdict.h"
 
 static ProxyLinkState *proxy_link;
 PCIDevice *remote_pci_dev;
@@ -181,6 +182,47 @@ fail:
     PUT_REMOTE_WAIT(wait);
 }
 
+static void process_device_del_msg(ProcMsg *msg)
+{
+    Error *local_err = NULL;
+    DeviceState *dev = NULL;
+    const char *json = (const char *)msg->data2;
+    int wait = msg->fds[0];
+    QObject *qobj = NULL;
+    QDict *qdict = NULL;
+    const char *id;
+
+    qobj = qobject_from_json(json, &local_err);
+    if (local_err) {
+        goto fail;
+    }
+
+    qdict = qobject_to(QDict, qobj);
+    assert(qdict);
+
+    id = qdict_get_try_str(qdict, "id");
+    assert(id);
+
+    dev = find_device_state(id, &local_err);
+    if (local_err) {
+        goto fail;
+    }
+
+    if (dev) {
+        qdev_unplug(dev, &local_err);
+    }
+
+fail:
+    if (local_err) {
+        error_report_err(local_err);
+        /* TODO: communicate the exact error message to proxy */
+    }
+
+    notify_proxy(wait, 1);
+
+    PUT_REMOTE_WAIT(wait);
+}
+
 static void process_msg(GIOCondition cond)
 {
     ProcMsg *msg = NULL;
@@ -235,6 +277,9 @@ static void process_msg(GIOCondition cond)
     case DEVICE_ADD:
         process_device_add_msg(msg);
         break;
+    case DEVICE_DEL:
+        process_device_del_msg(msg);
+        break;
     default:
         error_setg(&err, "Unknown command");
         goto finalize_loop;
diff --git a/stubs/monitor.c b/stubs/monitor.c
index a55b674777..ac24eeb5d4 100644
--- a/stubs/monitor.c
+++ b/stubs/monitor.c
@@ -51,3 +51,7 @@ ObjectPropertyInfoList *qmp_device_list_properties(const char *typename,
 void qmp_rdevice_add(QDict *qdict, QObject **ret_data, Error **errp)
 {
 }
+
+void qmp_rdevice_del(const char *id, Error **errp)
+{
+}